Bug 1021606 - resteasy-bom doesn't resolve org.jboss.resteasy:abdera-atom-provider:jar:2.3.7.Final [NEEDINFO]
resteasy-bom doesn't resolve org.jboss.resteasy:abdera-atom-provider:jar:2.3...
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: RESTEasy (Show other bugs)
Unspecified Unspecified
high Severity high
: CR1
: EAP 6.3.0
Assigned To: Weinan Li
Katerina Novotna
Depends On:
  Show dependency treegraph
Reported: 2013-10-21 11:43 EDT by Rafael Benevides
Modified: 2017-10-09 20:23 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2014-08-06 10:36:47 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
smumford: needinfo? (weli)

Attachments (Terms of Use)
test script (2.56 KB, application/x-shellscript)
2013-11-18 03:34 EST, Petr Sakař
no flags Details

External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker RESTEASY-971 Critical Closed Missing MavenCentral Dependencies on resteasy-bom 2016-12-14 04:15 EST

  None (edit)
Description Rafael Benevides 2013-10-21 11:43:28 EDT
Description of problem:

Version-Release number of selected component (if applicable): 6.2.0.Beta

How reproducible:

Run mvn -U org.jboss.maven.plugins:maven-qstools-plugin:1.2.4.Final:bom-check on EAP 6.2.0.Beta Boms

Steps to Reproduce:
1. Checkout https://github.com/jboss-developer/jboss-eap-boms
2. Change to 6.2.x branch: git checkout 6.2.x 
3. Run: mvn -U org.jboss.maven.plugins:maven-qstools-plugin:1.2.4.Final:bom-check

Actual results:
failed: Unable to collect/resolve dependency tree for a resulution due to: Could not find artifact org.jboss.resteasy:abdera-atom-provider:jar:2.3.7.Final

Expected results:
All Dependencies were resolved

Additional info:
Comment 1 JBoss JIRA Server 2013-10-21 11:46:30 EDT
Rafael Benevides <benevides@redhat.com> made a comment on jira RESTEASY-971

Resteasy 2.3.7 is used on EAP 6.2.0.Beta, that's why the priority was set to Critical
Comment 2 Paul Gier 2013-10-21 11:54:32 EDT
The versions in the resteasy bom should probably be changed to use the -redhat version for all artifacts.
Comment 3 Paul Gier 2013-10-21 11:56:27 EDT
Just to clarify previous comment, we probably want to trim the resteasy bom down to just the supported artifacts to make sure that we don't set a -redhat version for an artifact that is not shipped and supported with the maven repo zip.
Comment 4 Rafael Benevides 2013-10-22 10:45:30 EDT
The other issue is that abdera-atom-provider is not present on MavenCentral too: http://search.maven.org/#search%7Cgav%7C1%7Cg%3A%22org.jboss.resteasy%22%20AND%20a%3A%22abdera-atom-provider%22
Comment 5 Rafael Benevides 2013-10-23 15:45:17 EDT
We have two issues with this BOM:

1 - http://maven.repository.redhat.com/techpreview/eap6/6.2.0.Beta/maven-repository/org/jboss/resteasy/resteasy-bom/2.3.7.Final-redhat-2/resteasy-bom-2.3.7.Final-redhat-2.pom REferences non -redhat-x releases

2 - It references an non MavenCentral dependency:abdera-atom-provider 

So I'm increasing the Severity to High.
Comment 6 Weinan Li 2013-10-24 06:31:00 EDT
abdera-atom-provider is not supported by EAP/WildFly.

Here are the providers supported by EAP/WildFly:

Comment 7 Weinan Li 2013-10-24 06:37:38 EDT
I didn't notice 'resteasy-bom' module is used by project jboss-eap-boms.

Paul, do we have the requirement to support this project from EAP side? If so, from future I'll provide a managed 'resteasy-bom' module.
Comment 8 Paul Gier 2013-11-06 23:43:22 EST
Looks like there are actually two resteasy boms.
depends on 

I'm not really crazy about nested BOMs like this so it might be better to just put the correct managed dependencies directly into org.jboss.bom.eap:jboss-javaee-6.0-with-resteasy.

The other option is to remove unsupported stuff from org.jboss.resteasy:resteasy-bom as Weinan suggested.
Comment 9 Paul Gier 2013-11-07 00:05:02 EST
There is only one quickstart which currently uses jboss-javaee-6.0-with-resteasy (jax-rs-client) so it probably makes sense to limit this bom to only resteasy jars which are part of the supported eap 6 api (i.e. non-private modules in eap).
Comment 10 Weinan Li 2013-11-07 04:35:18 EST
(In reply to Paul Gier from comment #8)
> Looks like there are actually two resteasy boms.
> org.jboss.bom.eap:jboss-javaee-6.0-with-resteasy
> depends on 
> org.jboss.resteasy:resteasy-bom

Thanks for catching this Paul. 'org.jboss.bom.eap:jboss-javaee-6.0-with-resteasy' shouldn't import 'org.jboss.resteasy:resteasy-bom', because 'org.jboss.resteasy:resteasy-bom' is for upstream and it contains all the components of RESTEasy.

I'll help to create a PR to 'org.jboss.bom.eap:jboss-javaee-6.0-with-resteasy' and just put the resteasy components available in EAP modules.
Comment 11 Weinan Li 2013-11-07 04:43:15 EST
First commit: https://github.com/liweinan/jboss-eap-boms/commit/fb1dca70eaaa1abcf65321b6be67f32e2afa1e41

Hi Rafael, above are the resteasy components that we have in EAP6. Do you have any comments on it? If it's fine I'll go on adding the dependent artifacts of these components into pom.
Comment 12 Rafael Benevides 2013-11-07 07:35:19 EST
Hi Weinan Li,

If all of them can be resolved in EAP distro, than it's fine for me :)
Comment 13 Weinan Li 2013-11-11 02:47:14 EST
Thanks for clarification Rafael :-) I'll work on the dependencies, after finished them all I'll submit the PR.
Comment 14 Weinan Li 2013-11-11 03:46:52 EST
Hi Rafael, could you please tell me which repository I should use to test the BOM? 

Currently I'm running 'mvn -U org.jboss.maven.plugins:maven-qstools-plugin:1.2.4.Final:bom-check' in my local environment and it failed:

[ERROR]     Non-resolvable import POM: Could not find artifact org.jboss.spec:jboss-javaee-6.0:pom:3.0.2.Final-redhat-5 in central (http://repo.maven.apache.org/maven2) @ line 43, column 25 -> [Help 2]
Comment 15 Rafael Benevides 2013-11-11 05:43:06 EST
Hi Weinan,
You need to add http://maven.repository.redhat.com/earlyaccess/all
and http://maven.repository.redhat.com/techpreview/all/ to your settings.xml
Comment 16 Paul Gier 2013-11-11 22:17:33 EST
Weinan, you can also test with the latest build of the maven repo zip in jenkins:
Comment 17 Weinan Li 2013-11-12 00:34:31 EST
Thanks Paul & Rafael, I will go on testings with your information.
Comment 18 Weinan Li 2013-11-12 00:53:26 EST
Hi Rafael, I've met the following problem:

[ERROR] Failed to execute goal org.jboss.maven.plugins:maven-qstools-plugin:1.2.4.Final:bom-check (default-cli) on project jboss-javaee-6.0-with-resteasy: Execution default-cli of goal org.jboss.maven.plugins:maven-qstools-plugin:1.2.4.Final:bom-check failed: Could not create object from user view: InvocationTargetException: Could not create new service instance: org/sonatype/aether/resolution/DependencyResolutionException: org.sonatype.aether.resolution.DependencyResolutionException -> [Help 1]

Could you please tell me how to fix this? Here is the version of maven I'm using:

mini:jboss-javaee-6.0-with-resteasy weinanli$ mvn -version
Apache Maven 3.1.1 (0728685237757ffbf44136acec0402957f723d9a; 2013-09-17 23:22:22+0800)
Maven home: /usr/local/bin/apache-maven-3.1.1
Java version: 1.6.0_65, vendor: Apple Inc.
Java home: /System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home
Default locale: en_US, platform encoding: MacRoman
OS name: "mac os x", version: "10.9", arch: "x86_64", family: "mac"
Comment 19 Lin Gao 2013-11-12 02:27:06 EST
Hi Weinan, maven-qstools-plugins has problem on maven:3.1.X, see: https://github.com/jboss-developer/maven-qstools-plugin#checking-the-bom-dependencies

And also you need to test it by specifying the maven settings.xml by: -Dorg.apache.maven.user-settings=YOUR-MAVEN-SETTINGS.XML

FYI: https://issues.jboss.org/browse/JDF-539
Comment 20 Weinan Li 2013-11-12 09:19:45 EST
Hi Lin, thanks for these useful info!
Comment 21 Paul Gier 2013-11-12 11:41:28 EST
Rafael and I validated that the proposed fix is working.  
The PR is here: https://github.com/jboss-developer/jboss-eap-boms/pull/48
Comment 22 Paul Gier 2013-11-12 14:43:26 EST
I also added the -with-tools bom to the jax-rs-client quickstart to manage the version of JUnit.  Previously, the resteasy bom was providing the junit version.
Comment 23 Petr Sakař 2013-11-18 03:34:56 EST
Created attachment 825428 [details]
test script

1. create temporary directory and change into
2. download test.sh and jboss-eap-6.2.0.CR1-maven-repository.zip
3. run sh ./test.sh
Comment 24 Petr Sakař 2013-11-18 03:36:16 EST
failed using procedure described in comment#23
Comment 25 Rafael Benevides 2013-11-18 08:35:18 EST
regarding the test script on comment#23 I suggest using 'mvn -U org.jboss.maven.plugins:maven-qstools-plugin:bom-check' instead of 'mvn org.jboss.maven.plugins:maven-qstools-plugin:1.2.4.Final:bom-check' to always use the latest plugin version.
Comment 27 Weinan Li 2014-06-18 03:56:08 EDT
RESTEasy 2.3.8 in EAP 6.3 doesn't have this problem.
Comment 28 Katerina Novotna 2014-06-20 07:03:09 EDT
Verified jboss-javaee-6.0-with-resteasy-6.3.0.Beta2 is fixed in EAP 6.3.0.ER7.
Comment 30 JBoss JIRA Server 2016-04-29 19:35:38 EDT
Ron Sigal <ron.sigal@jboss.com> updated the status of jira RESTEASY-971 to Closed

Note You need to log in before you can comment on or make changes to this bug.